﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Algorithm
{
    public class CRC_Check
    {
        public byte CRC8Calculate(byte[] pbuf, int pBufSize) //CRC校验
        {
            byte retCRCValue = 0x00;
            int i = 0, j = 0;
            int pDataBuf = 0;
            int[] pData = new int[pBufSize];
            for (i = 0; i < pBufSize; i++)
                pData[i] = pbuf[i];

            while ((pBufSize--) > 0)
            {
                pDataBuf = pData[j];
                for (i = 0; i < 8; i++)
                {
                    if (((retCRCValue ^ (pDataBuf)) & 0x01) != 0)
                    {

                        retCRCValue ^= 0x01;
                        retCRCValue >>= 1;
                        retCRCValue |= 0x80;
                    }
                    else
                    {
                        retCRCValue >>= 1;
                    }
                    pDataBuf >>= 1;
                }
                j++;
            }
            return retCRCValue;
        }
    }
}
