﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Communication
{
    public class Communication_Function
    {
        public static int err_count;//错误计数

        /*****************************************************************************************************************
        函数名：Requst_Processing
        输入值：无
        返回值：无   
        功能说明：循坏等待编码器通讯请求→执行触发编码器通讯相关功能
        ******************************************************************************************************************/
        public static void Requst_Processing()
        {
            ZeroErr_Communication.Struct_eCoder_Data_Init();//初始化
            ZeroErr_Communication.Struct_eCoder_Inside_Status_Init();//初始化
            while (err_count < 10)//错误计数>10,则跳出循环
            {
                if (ZeroErr_Communication.Struct_Request_Mode.read_eCoder_Information)//读取编码器信息:单圈多圈位置、分辨率_持续请求
                {
                    if (ZeroErr_Communication.Read_eCoder_Information() == 0)
                    {
                        err_count++;
                    }
                }

                if (ZeroErr_Communication.Struct_Request_Mode.set_Single_Turn_To_Zero)//单圈清零请求_单次请求
                {
                    if (ZeroErr_Communication.Set_Single_To_Zero() == 0)
                    {
                        err_count++;
                    }
                    Thread.Sleep(600);//等待600ms
                    ZeroErr_Communication.Struct_Request_Mode.set_Single_Turn_To_Zero = false;
                }

                if (ZeroErr_Communication.Struct_Request_Mode.set_Multi_Turn_To_Zero)//多圈复位请求_单次请求
                {
                    if (ZeroErr_Communication.Set_Multi_To_Zero() == 0)
                    {
                        err_count++;
                    }
                    Thread.Sleep(800);//等待800ms
                    ZeroErr_Communication.Struct_Request_Mode.set_Multi_Turn_To_Zero = false;
                }

                if (ZeroErr_Communication.Struct_Request_Mode.read_eCoder_Status)//内部状态读取_单次请求
                {
                    ZeroErr_Communication.Read_eCoder_Inside_Status();
                    ZeroErr_Communication.Struct_Request_Mode.read_eCoder_Status = false;
                }
            }
        }
    }
}
